//+------------------------------------------------------------------+
//|                                                     ZZ-Trend.mq4 |
//|                                         Copyright  2009, Kharko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Kharko"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Blue

extern color
         ZZcolor  = Blue;//   
extern int 
         ZZwidth   = 1;   //  
extern color  MarkColor  =Blue;
extern int    MarkNumber =217;
double
   LowBuffer[],
   HighBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//---- drawing settings
   SetIndexBuffer(0,LowBuffer);
   SetIndexBuffer(1,HighBuffer);
   SetIndexStyle(0,DRAW_ZIGZAG,STYLE_SOLID,ZZwidth,ZZcolor);
   SetIndexStyle(1,DRAW_ZIGZAG,STYLE_SOLID,ZZwidth,ZZcolor);
//---- indicator buffers mapping
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(0,"ZigZag_Low" );
   SetIndexLabel(1,"ZigZag_High" );
//---- indicator short name
   IndicatorShortName("ZZ-Trend");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    
      NewPeriod,
      index,
      indHigh,
      indLow;
   double
      prHigh,
      prLow;
   datetime
      time1;
//----
   string buff_str="ZZ-Trend_StartBar";
   if(ObjectFind(buff_str)==-1)
   {
      ObjectCreate(buff_str, OBJ_ARROW,0, Time[16], Low[16]-2*Point );
      ObjectSet(buff_str, OBJPROP_ARROWCODE, MarkNumber);
      ObjectSet(buff_str, OBJPROP_COLOR, MarkColor);
      NewPeriod=16;
      time1=Time[16];
   }
   else
   {
      ObjectSet(buff_str, OBJPROP_ARROWCODE, MarkNumber);
      ObjectSet(buff_str, OBJPROP_COLOR, MarkColor);
      time1=ObjectGet(buff_str,OBJPROP_TIME1);
      NewPeriod=iBarShift(NULL,0,time1,false);
   }

   ArrayInitialize(LowBuffer,0);
   ArrayInitialize(HighBuffer,0);
   indLow=iLowest(NULL,0,MODE_LOW,NewPeriod,0);
   LowBuffer[indLow]=Low[indLow];
   indHigh=iHighest(NULL,0,MODE_HIGH,NewPeriod,0);
   HighBuffer[indHigh]=High[indHigh];
   
   if(indHigh>indLow)
      index=indLow;
   else
      index=indHigh;
   
   while(index>0)
   {
      indLow=iLowest(NULL,0,MODE_LOW,index,0);
      LowBuffer[indLow]=Low[indLow];
      indHigh=iHighest(NULL,0,MODE_HIGH,index,0);
      HighBuffer[indHigh]=High[indHigh];

      if(indHigh>indLow)
         index=indLow;
      else
         index=indHigh;
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+